# file: baseConversions.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
# Some code for converting between bases, representing numerals as lists
# of digits.

# decimalTo : int * int -> int list
#
# The call decimalTo(n, base) returns the list of digits representing decimal
# numeral n in the given base.
#
def decimalTo(N, base):
    def repeat(N, base, answer):
        if N == 0:
            return answer
        else:
            (rest, digit) = (N / base, N % base)
            return repeat(rest, base, [digit] + answer)
    return repeat(N, base, [])

# Same function without using recursion.
#
def decimalTo(N, base):
    answer = []
    while N > 0:
        (N, digit) = (N / base, N % base)
        answer.append(digit)
    answer.reverse()
    return answer

# toDecimal : int list * int -> int
#
# The call toDecimal(digits, base) returns the decimal numeral corresponding
# to digits.
#
def toDecimal(digits, base):
    if digits == []:
        return 0
    else:
        first = digits[0]
        rest = digits[1:]
        return first * (base ** len(rest)) + toDecimal(rest, base)

# Same function without using recursion.
#
def toDecimal(digits, base):
    answer = 0
    for i in range(len(digits)):
        answer = answer + digits[i] * (base ** (len(digits) - i - 1))
    return answer

    
# atoi : string -> int
#
# The call atoi(N) accepts a string of digits N and returns the
# integer represented by the string. E.g., atoi('12') returns 12.
#
def atoi(N):
    def repeat(digits, answer):
        if digits == []:
            return answer
        else:
            digit = ord(digits[0]) - ord('0')
            return repeat(digits[1:], answer * 10 + digit)
    return repeat(list(N), 0)


# Or, non-recursively using mutation:

def atoi(N):
    answer = 0
    for digit in list(N):
        answer = answer * 10 + (ord(digit) - ord('0'))
    return answer
