# file: rippleCarryAdder.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
# Some code for implementing a full adder and a ripple carry
# adder in Python.
#
def reverse(list): return list[::-1]

def xor(digit1, digit2): return digit1 != digit2

def fullAdder(a, b, cIn):
    c = xor(a, b)
    sum = xor(c, cIn)
    cOut = c and cIn or (a and b)
    return (sum, cOut)
            
def rippleCarryAdder(ms, ns):
    def repeat(ms, ns, carryIn, answer):
        
        if ms == []: return (carryIn, ns + answer)
        if ns == []: return (carryIn, ms + answer)

        (digit, carryOut) = fullAdder(ms[0], ns[0], carryIn)
        return repeat(ms[1:], ns[1:], carryOut, [digit] + answer)
    
    return repeat(reverse(ms), reverse(ns), False, [])

n1 = [True, False, True]
n2 = [False, True, True]
